Package org.eclipse.lemminx.services.extensions.codeaction

## Interface ICodeActionParticipant

All Known Implementing Classes:
  `AbstractFixMissingGrammarCodeAction`, `CloseTagCodeAction`, `ContentModelCodeActionParticipant`, `cvc_attribute_3CodeAction`, `cvc_complex_type_2_1CodeAction`, `cvc_complex_type_2_3CodeAction`, `cvc_complex_type_2_4_aCodeAction`, `cvc_complex_type_2_4_bCodeAction`, `cvc_complex_type_3_2_2CodeAction`, `cvc_complex_type_4CodeAction`, `cvc_elt_1_aCodeAction`, `cvc_enumeration_validCodeAction`, `cvc_type_3_1_1CodeAction`, `DownloadDisabledResourceCodeAction`, `DTDNotFoundCodeAction`, `ElementDeclUnterminatedCodeAction`, `ElementUnterminatedCodeAction`, `EntityNotDeclaredCodeAction`, `EqRequiredInAttributeCodeAction`, `ETagRequiredCodeAction`, `ETagUnterminatedCodeAction`, `FixMissingSpaceCodeAction`, `MarkupEntityMismatchCodeAction`, `MinifyCodeActionParticipant`, `NoGrammarConstraintsCodeAction`, `OpenQuoteExpectedCodeAction`, `required_element_missingCodeAction`, `required_elements_missing_expectedCodeAction`, `RootElementTypeMustMatchDoctypedeclCodeAction`, `s4s_elt_invalid_content_3CodeAction`, `schema_reference_4CodeAction`, `SemicolonRequiredInReferenceCodeAction`, `src_annotationCodeAction`, `src_import_1_2CodeAction`, `TargetNamespace_1CodeAction`, `TargetNamespace_2CodeAction`

    public interface ICodeActionParticipant

Code action participant API.

Author:
  Angelo ZERR

### Method Summary

All Methods Instance Methods Default Methods
`default void` `doCodeAction​(ICodeActionRequest request, List<org.eclipse.lsp4j.CodeAction> codeActions, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Collect the code action in the given `codeActions` for the given code action request `request`.
`default void` `doCodeActionUnconditional​(ICodeActionRequest request, List<org.eclipse.lsp4j.CodeAction> codeActions, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Collect the code action in the given `codeActions` for the given code action request `request` independently of diagnostic provided.
`default ICodeActionResolvesParticipant` `getResolveCodeActionParticipant​(String participantId)` Returns the codeAction resolver participant identified by the given `participantId` and null otherwise.

### Method Detail

#### doCodeAction

    default void doCodeAction​(ICodeActionRequest request,
                              List<org.eclipse.lsp4j.CodeAction> codeActions,
                              org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
                       throws CancellationException

Collect the code action in the given `codeActions` for the given code action request `request`.

Parameters:
  `request` - the code action request.
  `codeActions` - list of code actions to fill.
  `cancelChecker` - the cancel checker.
Throws:
  `CancellationException` - if the computation was cancelled

#### doCodeActionUnconditional

    default void doCodeActionUnconditional​(ICodeActionRequest request,
                                           List<org.eclipse.lsp4j.CodeAction> codeActions,
                                           org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
                                    throws CancellationException

Collect the code action in the given `codeActions` for the given code action request `request` independently of diagnostic provided.

Parameters:
  `request` - the code action request.
  `codeActions` - list of code actions to fill.
  `cancelChecker` - the cancel checker.
Throws:
  `CancellationException` - if the computation was cancelled
Since:
  0.26

#### getResolveCodeActionParticipant

    default ICodeActionResolvesParticipant getResolveCodeActionParticipant​(String participantId)

Returns the codeAction resolver participant identified by the given `participantId` and null otherwise.

Parameters:
  `participantId` - the code action resolver participant ID.
Returns:
  the codeAction resolver participant identified by the given `participantId` and null otherwise.